Bug 823170 - Review Request: leveldb - A fast and lightweight key/value database library by Google
Review Request: leveldb - A fast and lightweight key/value database library b...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jonathan Dieter
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 823171
  Show dependency treegraph
 
Reported: 2012-05-19 13:59 EDT by Peter Lemenkov
Modified: 2012-07-23 16:30 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-07-17 12:47:40 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jdieter: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Lemenkov 2012-05-19 13:59:18 EDT
Spec URL: http://peter.fedorapeople.org/leveldb.spec
SRPM URL: http://peter.fedorapeople.org/leveldb-1.4.0-1.fc18.src.rpm
Description: LevelDB is a fast key-value storage library written at Google that provides an ordered mapping from string keys to string values.

NotReady - I still need to add tests to autotools and pkgconfig file.
Comment 1 Peter Lemenkov 2012-05-21 10:59:42 EDT
Clean up NotReady. It builds fine in Koji and passes all the tests. Unfortunately it doesn't work well on PowerPC due to several endianness issues here and there (I'm working on it) so ExclusiveArch for now.

Koji scratchbuild:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4091585

rpmlint:
work ~: rpmlint Desktop/leveldb-*
leveldb.src: W: invalid-url Source0: http://leveldb.googlecode.com/files/leveldb-1.4.0.tar.gz HTTP Error 404: Not Found

^^^ something wrong with rpmlint I suppose..

leveldb.x86_64: W: shared-lib-calls-exit /usr/lib64/libleveldb.so.1.0.4 exit@GLIBC_2.2.5

^^^ Unfortunately that's how it was designed by Google. I'll try to improve it but I wouldn't hold my breath waiting for that.

leveldb-devel.x86_64: W: no-documentation

^^^ Yep, no docs for devel package.

4 packages and 0 specfiles checked; 0 errors, 3 warnings.
work ~:
Comment 2 Peter Lemenkov 2012-05-29 08:49:02 EDT
Raising NotReady again. I'll try to address non-x88 related issues first.
Comment 3 Peter Lemenkov 2012-07-05 10:55:24 EDT
Ok, all major issues with secondary arches are addressed (at least it passes a majority of unit-tests - I've got several issues with ppc/ppc64 and some weird irreproducible errors on s390x) so I'm lifting NotReady. I'm working on the remaining issues on a secondary arches but I'm sure this is not a blocker.

* http://peter.fedorapeople.org/leveldb.spec
* http://peter.fedorapeople.org/leveldb-1.5.0-1.fc18.src.rpm

Koji build for Rawhide (x86, x86_64):

* http://koji.fedoraproject.org/koji/taskinfo?taskID=4219934

Koji build for Rawhide (ppc, ppc64):

* http://ppc.koji.fedoraproject.org/koji/taskinfo?taskID=605930

Koji build for F18 (s390, s390x):

* http://s390.koji.fedoraproject.org/koji/taskinfo?taskID=715024

Koji build for F18 (arm):

* http://arm.koji.fedoraproject.org/koji/taskinfo?taskID=943513
Comment 4 Jonathan Dieter 2012-07-10 08:35:56 EDT
Taking this as it's also needed for ceph.
Comment 5 Jonathan Dieter 2012-07-10 09:32:39 EDT
[jonathan@jdlaptop SPECS]$ rpmlint leveldb.spec
leveldb.spec: W: patch-not-applied Patch3: leveldb-0003-Woarkaround-for-PowerPC-bloom-test-FIXME.patch
0 packages and 1 specfiles checked; 0 errors, 1 warnings.
[jonathan@jdlaptop SPECS]$ rpmlint ../SRPMS/leveldb-1.5.0-1.fc17.src.rpm 
leveldb.src: W: patch-not-applied Patch3: leveldb-0003-Woarkaround-for-PowerPC-bloom-test-FIXME.patch
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
[jonathan@jdlaptop SPECS]$ rpmlint ../RPMS/x86_64/leveldb-1.5.0-1.fc17.x86_64.rpm 
leveldb.x86_64: W: shared-lib-calls-exit /usr/lib64/libleveldb.so.1.0.5 exit@GLIBC_2.2.5
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
[jonathan@jdlaptop SPECS]$ rpmlint ../RPMS/x86_64/leveldb-devel-1.5.0-1.fc17.x86_64.rpm 
leveldb-devel.x86_64: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

The only difference with what you saw is the fact that you're no longer applying Patch3.  Whenever you push out your next release, please either apply it or remove it.
Comment 6 Jonathan Dieter 2012-07-10 09:54:36 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Package is not relocatable.


==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/jonathan/rpmbuild/SPECS/823170/leveldb-1.5.0.tar.gz :
  MD5SUM this package     : 6797e19a0a9f9bb1c1ba356bf89227f0
  MD5SUM upstream package : 6797e19a0a9f9bb1c1ba356bf89227f0

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[?]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[!]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean

[!]: MUST Rpmlint output is silent.
Please note my previous comment.

[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None

[!]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
See: http://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

Generated by fedora-review 0.1.3

So, there are really three issues here.  The first is that you have some legacy buildroot stuff going on that's only needed if you're planning on building for EPEL-5.  If you are, I'm happy to approve this, otherwise, please remove

The second is the rpmlint output, and the only thing I really care about is the stuff about Patch3.

Finally, you have two patches (that are being used), and I'd love to either see upstream bug reports with the patches included or comments in the spec explaining why not.
Comment 7 Peter Lemenkov 2012-07-11 02:31:31 EDT
(In reply to comment #6)

> So, there are really three issues here.  The first is that you have some
> legacy buildroot stuff going on that's only needed if you're planning on
> building for EPEL-5.  If you are, I'm happy to approve this, otherwise,
> please remove

I plan to build it only for EL6 and F17+. So what exactly not needed for EL6?


> The second is the rpmlint output, and the only thing I really care about is
> the stuff about Patch3.

Dropped this patch. It didn't fix the failing test in ppc anyway. Here is  new package:

* http://peter.fedorapeople.org/leveldb.spec
* http://peter.fedorapeople.org/leveldb-1.5.0-2.fc18.src.rpm

> Finally, you have two patches (that are being used), and I'd love to either
> see upstream bug reports with the patches included or comments in the spec
> explaining why not.

Well, the short answer is I just didn't have time to send them. This package is a part of a much more bigger picture - inclusion of Riak in fedora. I created a several dozens of patches for different libraries while working on this task and already submitted some of them but not all of them. I'll do.

Regarding these patch I wouldn't be too optimistic - especially about patch #1. It seems that internal development culture in Google (the upstream of this library) becomes less and less friendly to the OSS community in general and to the volunteers outside of Google in particular.

For example they constantly create their own buggy and incompatible tools and set up their own infrastructure instead of re-using standard and proven  components (build systems, issue trackers). They also have a very bad habit of forking and bundling other projects within their own ones instead of working with upstream.

Anyway I'll try to send these patches to them as soon as I've some free time.
Comment 8 Jonathan Dieter 2012-07-11 06:49:59 EDT
(In reply to comment #7)
> (In reply to comment #6)
> 
> > So, there are really three issues here.  The first is that you have some
> > legacy buildroot stuff going on that's only needed if you're planning on
> > building for EPEL-5.  If you are, I'm happy to approve this, otherwise,
> > please remove
> 
> I plan to build it only for EL6 and F17+. So what exactly not needed for EL6?

You've already done it in your last spec.  You just needed to get rid of the %clean section and the rm -rf $BUILDROOT at the beginning of the %install section.

> > The second is the rpmlint output, and the only thing I really care about is
> > the stuff about Patch3.
> 
> Dropped this patch. It didn't fix the failing test in ppc anyway. Here is 
> new package:
> 
> * http://peter.fedorapeople.org/leveldb.spec
> * http://peter.fedorapeople.org/leveldb-1.5.0-2.fc18.src.rpm

Looks great!

> > Finally, you have two patches (that are being used), and I'd love to either
> > see upstream bug reports with the patches included or comments in the spec
> > explaining why not.
> 
> Well, the short answer is I just didn't have time to send them. This package
> is a part of a much more bigger picture - inclusion of Riak in fedora. I
> created a several dozens of patches for different libraries while working on
> this task and already submitted some of them but not all of them. I'll do.
> 
> Regarding these patch I wouldn't be too optimistic - especially about patch
> #1. It seems that internal development culture in Google (the upstream of
> this library) becomes less and less friendly to the OSS community in general
> and to the volunteers outside of Google in particular.
> 
> For example they constantly create their own buggy and incompatible tools
> and set up their own infrastructure instead of re-using standard and proven 
> components (build systems, issue trackers). They also have a very bad habit
> of forking and bundling other projects within their own ones instead of
> working with upstream.
> 
> Anyway I'll try to send these patches to them as soon as I've some free time.

I'm not to pushed with whether or not they decide to take the patches, but I'd like to make sure that *we're* being good citizens, whatever others may do.

If you could just open up an issue for each patch at https://code.google.com/p/leveldb/issues/list and list the links to the issues in the spec file, that would easily satisfy the requirements.

I'm going to go ahead and APPROVE this review, but I'd appreciate it if you do the above before you push the initial release.
Comment 9 Peter Lemenkov 2012-07-11 07:09:50 EDT
Hello again. I've just sent patches upstream and added a note in the spec-file regarding their status:

* http://peter.fedorapeople.org/leveldb.spec
* http://peter.fedorapeople.org/leveldb-1.5.0-2.fc18.src.rpm
Comment 10 Jonathan Dieter 2012-07-11 09:16:34 EDT
That looks great!  I've already set the fedora-review flag so you should be set!
Comment 11 Peter Lemenkov 2012-07-11 09:21:05 EDT
(In reply to comment #10)
> That looks great!  I've already set the fedora-review flag so you should be
> set!

Thanks!

New Package SCM Request
=======================
Package Name: leveldb
Short Description: A fast and lightweight key/value database library by Google
Owners: peter
Branches: f17 el6
InitialCC:
Comment 12 Jason Tibbitts 2012-07-13 19:30:36 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2012-07-14 00:28:23 EDT
leveldb-1.5.0-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/leveldb-1.5.0-2.fc17
Comment 14 Fedora Update System 2012-07-14 17:49:37 EDT
leveldb-1.5.0-2.fc17 has been pushed to the Fedora 17 testing repository.
Comment 15 Fedora Update System 2012-07-23 16:30:58 EDT
leveldb-1.5.0-2.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.